/*
 INTEGER_test.cc
 
 Small test routine to check basic properties of the INTEGER data type.
 

*/
#include "iRRAM.h"

void error(int i){
cerr << "INTEGER test: Error "<< i <<"\n";
exit(1);
}

void compute(){
 INTEGER x=3;
 INTEGER y=-7;
 INTEGER z;
 int    i;
 
 if ( ! (x>0)   )  error(1); 
 if ( (x<0)     )  error(2); 
 if ( (x == 0)  )  error(3); 
 if ( !(x != 0) )  error(4); 

 if ( (y>0)     )  error(5); 
 if ( !(y<0)    )  error(6); 
 if ( (y == 0)  )  error(7); 
 if ( !(y != 0) )  error(8); 

 if ( (z>0)   )    error(9); 
 if ( (z<0)     )  error(10); 
 if ( (z != 0)  )  error(11); 
 if ( !(z == 0) )  error(12); 

 if ( x*y != -21)  error(13); 
 if ( x+y != -4 )  error(14); 
 if ( x-y != 10 )  error(15); 
 
 if ( x*(-7) != -21)  error(16); 
 if ( x+(-7) != -4 )  error(17); 
 if ( x-(-7) != 10 )  error(18); 
 if ( 3-y    != 10 )  error(19); 

 if ( abs(y) !=  7 )  error(20);
 if ( abs(x) !=  3 )  error(21);

 if ( INTEGER(0).size() != 0 )  error(22);
 if ( INTEGER(1).size() != 1 )  error(22);
 if ( INTEGER(2).size() != 2 )  error(22);
 if ( INTEGER(3).size() != 2 )  error(22);
 if ( INTEGER(4).size() != 3 )  error(22);
 if ( INTEGER(1048576).size() != 21 ) error(23);
 { INTEGER m=INTEGER(1048576);
   m=m*m;
   m=m*m;
   m=m*m;   
   if ( m.size() != 161 ) error(24);
   if ( m <= 0 ) error(25);
   if ( -m > 0 ) error(26);
 }
 if ( y.size() != 3 )  error(27);
 if ( z.size() != 0 )  error(28);
 
/* if ( shift(x,2) !=12 ) error(22);
 if ( shift(y,2) !=-28 ) error(23);
 
 z=-28;
 if ( shift(z,-2) !=-7 ) error(24);
 z= 12;
 if ( shift(z,-2) != 3 ) error(25);

 i=DYADIC(3);
 if ( i != 3   ) error(26);
 i=DYADIC(-28);
 if ( i != -28 ) error(27);
 
 i=shift(DYADIC(15),-3);
 if ( i != 1   ) error(28);
 i=shift(DYADIC(17),-3);
 if ( i != 2   ) error(29);
 i=shift(DYADIC(-15),-3);
 if ( i != -1   ) error(28);
 i=shift(DYADIC(-17),-3);
 if ( i != -2   ) error(29);
*/

cout << "INTEGER test: OK\n";
exit(0);
};
