#define do_not_activate_iRRAM_control

#include "iRRAM.h"
#include "iRRAM_core.h"
#include <list>

#define N 2

template int iRRAM_exec <int,char **> (int (*) (int,char **),int,char **);
using namespace std;

// void rwrite(INTERVAL i,int w){rprintf("[");rwrite(inf(i),w);rprintf(",");rwrite(sup(i),w);rprintf("[");};
void rwrite (const INTERVAL& x, const int w)
{
	rprintf("[ "); rwrite(inf(x), w);
	rprintf("  ,  ");
	rwrite(sup(x), w); rprintf(" ]");
	return;
}


class CIBox {
	private:
	INTERVAL m_IX;
	INTERVAL m_IY;

	public:
	CIBox()
		{ m_IX = INTERVAL(0,0); m_IY = INTERVAL(0,0); }
	CIBox(INTERVAL IX, INTERVAL IY)
		{ m_IX = IX; m_IY = IY; }

	INTERVAL first()
		{ return m_IX; }
	INTERVAL second()
		{ return m_IY; }
};

class CIBoxes : public::list<CIBox> {
	public:
	void circumscribe(INTERVAL (*func)(const INTERVAL&), INTERVAL IX, REAL eps) {
		long int k=2*upperbound(eps)+2;
		REAL shift=power(REAL(2),k);
		INTERVAL IY = func(IX);
		rprintf("  --> IX = "); rwrite(IX,20); rprintf("\n");

		if (!positive(wid(IY)-eps+shift, k)) {
			this->push_back(CIBox(IX,IY));
		}
		else {
			INTERVAL Isubint;
			INTERVAL Istep = INTERVAL( (sup(IX)-inf(IX)) / N);
				for (int i=0; i<N; i++) {
				Isubint = INTERVAL(inf(IX)) + INTERVAL(i,i+1) * Istep;
				this->circumscribe(func,Isubint,eps);
			}
		}
		return;
	}
};


int iRRAM_compute(int argc, char **argv) {
	INTERVAL (*derivative)(const INTERVAL&);
	derivative = cos;
	INTERVAL IX = INTERVAL(0,1);
	REAL precision="0.0001";
	CIBoxes recs;

	/* Norbert, if the line below is uncommented - it's OK
	 * If it is commented - gives me a segmenation fault
	 * Why?
	 */
//	rprintf("  IX = "); rwrite(IX,20); rprintf("\n");
	recs.circumscribe(derivative,IX,precision);
}

int main(int argc, char** argv) {
	iRRAM_initialize(argc,argv);
	iRRAM_exec(iRRAM_compute,argc,argv);
}

